set echo on
set termout on
set feedback on

set pagesize 500
set long 40000

cl scr



select utl_http.request('http://technology.amis.nl/blog/?feed=rss2')
from   dual

pause

/




pause




create or replace view AMIS_WEBLOG_FEED
as
select title
,      link
,      author
,      to_date(substr(publication_date,6,20),'dd mon yyyy hh24:mi:ss') timest
from  xmltable(XMLNAMESPACES('http://purl.org/dc/elements/1.1/' AS "dc"),'for $i in //item
                  return <Article>{$i/title}{$i/dc:creator}{$i/pubDate}{$i/link}</Article>
                 ' 
                 passing httpuritype('http://technology.amis.nl/blog/?feed=rss2').getXML()
                  COLUMNS
                  title     varchar2(100) path 'title'
                  , link     varchar2(100) path 'link'
                  , author     varchar2(100) path 'dc:creator'
                  , publication_date     varchar2(100) path 'pubDate'
               ) 
/

pause

select *
from   amis_weblog_feed

pause

/


               
select title
,      timest
,      author
from   amis_weblog_feed
where  instr(lower(title), 'oow') > 0



pause

/


rem News feeds:


pause


create or replace view NEWS_FEEDS_AGGREGATOR
as
select title
,      link
,      author
,      to_date(substr(publication_date,6,20),'dd mon yyyy hh24:mi:ss') timest
from  ( select column_value feed
        from   table( string_table( 'http://newsrss.bbc.co.uk/rss/newsonline_world_edition/front_page/rss.xml'
                                  , 'http://rss.cnn.com/rss/edition.rss'
                                  )
                     ) 
      ) feeds 
,     xmltable(XMLNAMESPACES('http://purl.org/dc/elements/1.1/' AS "dc"),'for $i in //item
                  return <Article>{$i/title}{$i/dc:creator}{$i/pubDate}{$i/link}</Article>
                 ' 
                 passing httpuritype(feeds.feed).getXML()
                  COLUMNS
                  title     varchar2(100) path 'title'
                  , link     varchar2(100) path 'link'
                  , author     varchar2(100) path 'dc:creator'
                  , publication_date     varchar2(100) path 'pubDate'
               )     
pause
               
                
/


select *
from   NEWS_FEEDS_AGGREGATOR

pause

/




pause

merge into rss_archive arch
using ( select title
        ,      link
        ,      author
        ,      to_date(substr(publication_date,6,20),'dd mon yyyy hh24:mi:ss') timest
        ,      feed
        from  rss_feeds feeds
        ,     xmltable( XMLNAMESPACES('http://purl.org/dc/elements/1.1/' AS "dc")
                       ,'for $i in //item
                        return <Article>{$i/title}{$i/dc:creator}{$i/pubDate}{$i/link}</Article>'
                        passing httpuritype(feeds.feedurl).getXML()
                        COLUMNS
                          title     varchar2(100) path 'title'
                        , link     varchar2(100) path 'link'
                        , author     varchar2(100) path 'dc:creator'
                        , publication_date     varchar2(100) path 'pubDate'
                      )
      ) rss_feed
on (arch.link = rss_feed.link)
when matched
then update 
     set    title = rss_feed.title,  author = rss_feed.author,  time = rss_feed.timest
when not matched
then insert (title, link, author, time, feed)
     VALUES (rss_feed.title, rss_feed.link, rss_feed.author, rss_feed.timest, rss_feed.feed)





pause

SELECT PROGRAM_NAME           
,      SCHEDULE_NAME          
,      NEXT_RUN_DATE
,      MAX_RUN_DURATION
,      LAST_START_DATE
,      RUN_COUNT
FROM   ALL_SCHEDULER_JOBs
WHERE  JOB_NAME = 'BIHOURLY_RSS_UPDATE'

pause

/

SELECT JOB_NAME, STATUS, ERROR#, additional_info
FROM ALL_SCHEDULER_JOB_RUN_DETAILS WHERE JOB_NAME = 'BIHOURLY_RSS_UPDATE'

pause

/


select count(*) 
from   rss_archive

pause

/


rem log errors into RSS_ARCHIVE_REFRESH_VIOLATIONS REJECT LIMIT UNLIMITED

select *
from   RSS_ARCHIVE_REFRESH_VIOLATIONS

pause

/


